﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.DataVisualization.DiagramEnums;
using Syncfusion.JavaScript.DataVisualization.Models.Controls;
using Syncfusion.JavaScript.DataVisualization.Models;
using System.Web.Script.Serialization;
using Syncfusion.JavaScript.DataVisualization.Models.Collections;
using MvcApplication60.Models;
using System.Data.Entity.Validation;

namespace MvcApplication60.Controllers
{
    public class EntityController : Controller
    {
        //
        // GET: /Entity/
        string sn, sn1;
        DiagramProperties model = new DiagramProperties();
        public ActionResult Index()
        {
            model.Width = "1000px";
            model.Height = "1000px";
            ViewData["diagramModel"] = model;
            return View();
        }

        [HttpPost]
        public ActionResult load(int id)
        {
            NorthwindcontextsDiagramEntities db = new NorthwindcontextsDiagramEntities();
            var chartstream = (from p in db.SaveDatabases
                               where p.Id == id
                               select p.Diagram2).FirstOrDefault();
            return Content(chartstream);
        }
        private Node createDiagram(string Emp_Id, string Emp_Head, string Emp_Name, int? width, int? height, string OffsetX, string OffsetY)
        {
            Node node = new Node();
            node.Width = Convert.ToDouble(width);
            node.Height = Convert.ToDouble(height);
            Syncfusion.JavaScript.DataVisualization.Models.Controls.Label label = new Syncfusion.JavaScript.DataVisualization.Models.Controls.Label();
            label.Text = Emp_Name;
            node.Labels.Add(label);
            node.OffsetX = Convert.ToDouble(OffsetX);
            node.OffsetY = Convert.ToDouble(OffsetY);
            node.Name = Emp_Id;
            node.BorderWidth = 1;
            node.BorderColor = "black";
            node.FillColor = "transparent";
            model.Nodes.Add(node);
            return node;
        }
        private void connectnodes(Node sourcenode, Node targetnode)
        {
            Connector connector = new Connector();
            connector.Name = "line" + model.Connectors.Count;
            connector.Line = new Orthogonal();
            connector.SourceNode = sourcenode;
            connector.TargetNode = targetnode;
            model.Connectors.Add(connector);
        }
        public Node FindNodeByName(string strNodeName)
        {
            foreach (Node node in this.model.Nodes)
            {
                if (node.Name == strNodeName)
                    return node;
            }
            return null;
        }

        public NorthwindcontextsDiagramEntities SqlCE
        {
            get
            {
                AppDomain.CurrentDomain.SetData("SQLServerCompactEditionUnderWebHosting", true);
                string connectionString = @"Data Source=|DataDirectory|\Diagram.sdf";
                return new NorthwindcontextsDiagramEntities(connectionString);
            }

        }
    }
}
